{*
 * File: ...................... ws_hook.pas
 * Autor: ..................... Maxim Artemev aka Bert Raccoon
 * Copyright: ................. (c) 2003 by Max Artemev, MC NTT (www.ntt.ru)
 * Desc: ...................... Hook and handle the Winsock functions
 *}
unit ws_hook;

interface
uses Windows, Sysutils, loger, syncobjs, winsock2, proxy, common, misc, cfg,
     sockschain, direct_addr, dns, SOCKS5Proxy{, plugin_disp};

type
    THookedFunction = record
       fnOrig  : Pointer;
       fnNew   : Pointer;
       fnName  : PChar;
       fnModule: PChar;
    end;

    procedure PrepareWSockHooks();
    procedure InstallWSockHooks(strModule: string);
    procedure InstallWSockHooks2(hMod: HMODULE);

    function GetHookedProc(fnName: string; fnOrig: Pointer): Pointer;

    function Hook_accept( const s: TSocket; var addr: TSockAddr; var addrlen: Integer ): TSocket; stdcall;
    function Hook_bind( const s: TSocket; const addr: PSockAddr; const namelen: Integer ): Integer; stdcall;
    function Hook_closesocket( const s: TSocket ): Integer; stdcall;
    function Hook_connect( const s: TSocket; const name: PSockAddr; namelen: Integer): Integer; stdcall;
    function Hook_ioctlsocket( const s: TSocket; const cmd: DWORD; var arg: u_long ): Integer; stdcall;
    function Hook_getpeername( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer; stdcall;
    function Hook_getsockname( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer; stdcall;
    function Hook_getsockopt( const s: TSocket; const level, optname: Integer; optval: PChar; var optlen: Integer ): Integer; stdcall;
    function Hook_htonl(hostlong: u_long): u_long; stdcall;
    function Hook_htons(hostshort: u_short): u_short; stdcall;
    function Hook_inet_addr(cp: PChar): u_long; stdcall;
    function Hook_inet_ntoa(inaddr: TInAddr): PChar; stdcall;
    function Hook_listen(s: TSocket; backlog: Integer): Integer; stdcall;
    function Hook_ntohl(netlong: u_long): u_long; stdcall;
    function Hook_ntohs(netshort: u_short): u_short; stdcall;
    function Hook_recv(s: TSocket; Buf: Pointer; len, flags: Integer): Integer; stdcall;
    function Hook_recvfrom(s: TSocket; Buf: Pointer; len, flags: Integer; var from: TSockAddr; var fromlen: Integer): Integer; stdcall;
    function Hook_select(nfds: Integer; readfds, writefds, exceptfds: PFDSet; timeout: PTimeVal): Integer; stdcall;
    function Hook_send(s: TSocket; Buf: Pointer; len, flags: Integer): Integer; stdcall;
    function Hook_sendto(s: TSocket; Buf: Pointer; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer; stdcall;
    function Hook_setsockopt(s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer; stdcall;
    function Hook_shutdown(s: TSocket; how: Integer): Integer; stdcall;
    function Hook_socket( const af, struct, protocol: Integer ): TSocket; stdcall;
    function Hook_gethostbyaddr(addr: Pointer; len, struct: Integer): PHostEnt; stdcall;
    function Hook_gethostbyname(name: PChar): PHostEnt; stdcall;
    function Hook_gethostname(name: PChar; len: Integer): Integer; stdcall;
    function Hook_getservbyport(port: Integer; proto: PChar): PServEnt; stdcall;
    function Hook_getservbyname(const name, proto: PChar): PServEnt; stdcall;
    function Hook_getprotobynumber(const proto: Integer): PProtoEnt; stdcall;
    function Hook_getprotobyname(const name: PChar): PProtoEnt; stdcall;
    function Hook_WSAStartup(wVersionRequired: word; var WSData: TWSAData): Integer; stdcall;
    function Hook_WSACleanup: Integer; stdcall;
    procedure Hook_WSASetLastError(iError: Integer); stdcall;
    function Hook_WSAGetLastError: Integer; stdcall;

    function Hook_WSAIsBlocking: BOOL; stdcall;
    function Hook_WSAUnhookBlockingHook: Integer; stdcall;
    function Hook_WSASetBlockingHook(lpBlockFunc: TFarProc): TFarProc; stdcall;
    function Hook_WSACancelBlockingCall: Integer; stdcall;
    function Hook_WSAAsyncGetServByName(HWindow: HWND; wMsg: u_int; name, proto, buf: PChar; buflen: Integer): THandle; stdcall;
    function Hook_WSAAsyncGetServByPort( HWindow: HWND; wMsg, port: u_int; proto, buf: PChar; buflen: Integer): THandle; stdcall;
    function Hook_WSAAsyncGetProtoByName(HWindow: HWND; wMsg: u_int; name, buf: PChar; buflen: Integer): THandle; stdcall;
    function Hook_WSAAsyncGetProtoByNumber(HWindow: HWND; wMsg: u_int; number: Integer; buf: PChar; buflen: Integer): THandle; stdcall;
    function Hook_WSAAsyncGetHostByName(HWindow: HWND; wMsg: u_int; name: PChar; buf: PHostEnt; buflen: Integer): THandle; stdcall;
    function Hook_WSAAsyncGetHostByAddr(HWindow: HWND; wMsg: u_int; addr: PChar; len, struct: Integer; buf: PChar; buflen: Integer): THandle; stdcall;
    function Hook_WSACancelAsyncRequest(hAsyncTaskHandle: THandle): Integer; stdcall;
    function Hook_WSAAsyncSelect(s: TSocket; HWindow: HWND; wMsg: u_int; lEvent: Longint): Integer; stdcall;
    function Hook___WSAFDIsSet(s: TSOcket; var FDSet: TFDSet): Bool; stdcall;
    function Hook_WSAAccept( s : TSocket; addr : TSockAddr; addrlen : PInteger; lpfnCondition : LPCONDITIONPROC; dwCallbackData : DWORD ): TSocket; stdcall;
    function Hook_WSACloseEvent( hEvent : WSAEVENT) : WordBool; stdcall;
    function Hook_WSAConnect( s : TSocket; const name : PSockAddr; namelen : Integer; lpCallerData,lpCalleeData : LPWSABUF; lpSQOS,lpGQOS : LPQOS ) : Integer; stdcall;
    function Hook_WSACreateEvent : WSAEVENT; stdcall;
    function Hook_WSADuplicateSocketA( s : TSocket; dwProcessId : DWORD; lpProtocolInfo : LPWSAProtocol_InfoA ) : Integer; stdcall;
    function Hook_WSADuplicateSocketW( s : TSocket; dwProcessId : DWORD; lpProtocolInfo : LPWSAProtocol_InfoW ) : Integer; stdcall;
    function Hook_WSAEnumNetworkEvents( const s : TSocket; const hEventObject : WSAEVENT; lpNetworkEvents : LPWSANETWORKEVENTS ) :Integer; stdcall;
    function Hook_WSAEnumProtocolsA( lpiProtocols : PInteger; lpProtocolBuffer : LPWSAProtocol_InfoA; var lpdwBufferLength : DWORD ) : Integer; stdcall;
    function Hook_WSAEnumProtocolsW( lpiProtocols : PInteger; lpProtocolBuffer : LPWSAProtocol_InfoW; var lpdwBufferLength : DWORD ) : Integer; stdcall;
    function Hook_WSAEventSelect( s : TSocket; hEventObject : WSAEVENT; lNetworkEvents : LongInt ): Integer; stdcall;
    function Hook_WSAGetOverlappedResult( s : TSocket; lpOverlapped : LPWSAOVERLAPPED; lpcbTransfer : LPDWORD; fWait : BOOL; var lpdwFlags : DWORD ) : WordBool; stdcall;
    function Hook_WSAGetQosByName( s : TSocket; lpQOSName : LPWSABUF; lpQOS : LPQOS ): WordBool; stdcall;
    function Hook_WSAhtonl( s : TSocket; hostlong : u_long; var lpnetlong : DWORD ): Integer; stdcall;
    function Hook_WSAhtons( s : TSocket; hostshort : u_short; var lpnetshort : WORD ): Integer; stdcall;
    function Hook_WSAIoctl( s : TSocket; dwIoControlCode : DWORD; lpvInBuffer : Pointer; cbInBuffer : DWORD; lpvOutBuffer : Pointer; cbOutBuffer : DWORD; lpcbBytesReturned : LPDWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ) : Integer; stdcall;
    function Hook_WSAJoinLeaf( s : TSocket; name : PSockAddr; namelen : Integer; lpCallerData,lpCalleeData : LPWSABUF; lpSQOS,lpGQOS : LPQOS; dwFlags : DWORD ) : TSocket; stdcall;
    function Hook_WSANtohl( s : TSocket; netlong : u_long; var lphostlong : DWORD ): Integer; stdcall;
    function Hook_WSANtohs( s : TSocket; netshort : u_short; var lphostshort : WORD ): Integer; stdcall;
    function Hook_WSARecv( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesRecvd : DWORD; var lpFlags : DWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
    function Hook_WSARecvDisconnect( s : TSocket; lpInboundDisconnectData : LPWSABUF ): Integer; stdcall;
    function Hook_WSARecvFrom( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesRecvd : DWORD; var lpFlags : DWORD; lpFrom : PSockAddr; lpFromlen : PInteger; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
    function Hook_WSAResetEvent( hEvent : WSAEVENT ): WordBool; stdcall;
    function Hook_WSASend( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesSent : DWORD; dwFlags : DWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
    function Hook_WSASendDisconnect( s : TSocket; lpOutboundDisconnectData : LPWSABUF ): Integer; stdcall;
    function Hook_WSASendTo( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesSent : DWORD; dwFlags : DWORD; lpTo : PSockAddr; iTolen : Integer; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
    function Hook_WSASetEvent( hEvent : WSAEVENT ): WordBool; stdcall;
    function Hook_WSASocketA( af, iType, protocol : Integer; lpProtocolInfo : LPWSAProtocol_InfoA; g : GROUP; dwFlags : DWORD ): TSocket; stdcall;
    function Hook_WSASocketW( af, iType, protocol : Integer; lpProtocolInfo : LPWSAProtocol_InfoW; g : GROUP; dwFlags : DWORD ): TSocket; stdcall;
    function Hook_WSAWaitForMultipleEvents( cEvents : DWORD; lphEvents : PWSAEVENT; fWaitAll : LongBool;	dwTimeout : DWORD; fAlertable : LongBool ): DWORD; stdcall;
    function Hook_WSAAddressToStringA( lpsaAddress : PSockAddr; const dwAddressLength : DWORD; const lpProtocolInfo : LPWSAProtocol_InfoA; const lpszAddressString : PChar; var lpdwAddressStringLength : DWORD ): Integer; stdcall;
    function Hook_WSAAddressToStringW( lpsaAddress : PSockAddr; const dwAddressLength : DWORD; const lpProtocolInfo : LPWSAProtocol_InfoW; const lpszAddressString : PWideChar; var lpdwAddressStringLength : DWORD ): Integer; stdcall;
    function Hook_WSAStringToAddressA( const AddressString : PChar; const AddressFamily: Integer; const lpProtocolInfo : LPWSAProtocol_InfoA; var lpAddress : TSockAddr; var lpAddressLength : Integer ): Integer; stdcall;
    function Hook_WSAStringToAddressW( const AddressString : PWideChar; const AddressFamily: Integer; const lpProtocolInfo : LPWSAProtocol_InfoA; var lpAddress : TSockAddr; var lpAddressLength : Integer ): Integer; stdcall;

    //  Registration and Name Resolution API functions
    function Hook_WSALookupServiceBeginA( var qsRestrictions : TWSAQuerySetA; const dwControlFlags : DWORD; var hLookup : THANDLE ): Integer; stdcall;
    function Hook_WSALookupServiceBeginW( var qsRestrictions : TWSAQuerySetW; const dwControlFlags : DWORD; var hLookup : THANDLE ): Integer; stdcall;
    function Hook_WSALookupServiceNextA( const hLookup : THandle; const dwControlFlags : DWORD; var dwBufferLength : DWORD; lpqsResults : PWSAQuerySetA ): Integer; stdcall;
    function Hook_WSALookupServiceNextW( const hLookup : THandle; const dwControlFlags : DWORD; var dwBufferLength : DWORD; lpqsResults : PWSAQuerySetW ): Integer; stdcall;
    function Hook_WSALookupServiceEnd( const hLookup : THandle ): Integer; stdcall;
    function Hook_WSAInstallServiceClassA( const lpServiceClassInfo : LPWSAServiceClassInfoA ) : Integer; stdcall;
    function Hook_WSAInstallServiceClassW( const lpServiceClassInfo : LPWSAServiceClassInfoW ) : Integer; stdcall;
    function Hook_WSARemoveServiceClass( const lpServiceClassId : PGUID ) : Integer; stdcall;
    function Hook_WSAGetServiceClassInfoA( const lpProviderId : PGUID; const lpServiceClassId : PGUID; var lpdwBufSize : DWORD; lpServiceClassInfo : LPWSAServiceClassInfoA ): Integer; stdcall;
    function Hook_WSAGetServiceClassInfoW( const lpProviderId : PGUID; const lpServiceClassId : PGUID; var lpdwBufSize : DWORD; lpServiceClassInfo : LPWSAServiceClassInfoW ): Integer; stdcall;
    function Hook_WSAEnumNameSpaceProvidersA( var lpdwBufferLength: DWORD; const lpnspBuffer: LPWSANameSpace_InfoA ): Integer; stdcall;
    function Hook_WSAEnumNameSpaceProvidersW( var lpdwBufferLength: DWORD; const lpnspBuffer: LPWSANameSpace_InfoW ): Integer; stdcall;
    function Hook_WSAGetServiceClassNameByClassIdA( const lpServiceClassId: PGUID; lpszServiceClassName: PChar; var lpdwBufferLength: DWORD ): Integer; stdcall;
    function Hook_WSAGetServiceClassNameByClassIdW( const lpServiceClassId: PGUID; lpszServiceClassName: PWideChar; var lpdwBufferLength: DWORD ): Integer; stdcall;
    function Hook_WSASetServiceA( const lpqsRegInfo: LPWSAQuerySetA; const essoperation: TWSAeSetServiceOp; const dwControlFlags: DWORD ): Integer; stdcall;
    function Hook_WSASetServiceW( const lpqsRegInfo: LPWSAQuerySetW; const essoperation: TWSAeSetServiceOp; const dwControlFlags: DWORD ): Integer; stdcall;
    function Hook_WSAProviderConfigChange( var lpNotificationHandle : THandle; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ) : Integer; stdcall;
    function Hook_getaddrinfo(nodename, servname: PChar; hints: PAddrInfo; res: PPAddrInfo): integer; stdcall;
    procedure Hook_freeaddrinfo(ai: PAddrInfo); stdcall;

const
     WINSOCKLIB = 'wsock32.dll';
     SYNC_CONNECT_MUTEX = 'FreeCap$MUTEX$CONNECT';


var
    HookedFunctions : array[0..37  + 8 {+ 62 - 6} + 19]  of THookedFunction = (
    (fnOrig : nil; fnNew: @Hook_accept; fnName: 'accept'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_bind; fnName: 'bind'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_closesocket; fnName: 'closesocket'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_connect; fnName: 'connect'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_ioctlsocket; fnName: 'ioctlsocket'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getpeername; fnName: 'getpeername'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getsockname; fnName: 'getsockname'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getsockopt; fnName: 'getsockopt'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_htonl; fnName: 'htonl'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_htons; fnName: 'htons'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_inet_addr; fnName: 'inet_addr'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_inet_ntoa; fnName: 'inet_ntoa'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_listen; fnName: 'listen'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_ntohl; fnName: 'ntohl'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_ntohs; fnName: 'ntohs'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_recv; fnName: 'recv'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_recvfrom; fnName: 'recvfrom'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_select; fnName: 'select'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_send; fnName: 'send'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_sendto; fnName: 'sendto'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_setsockopt; fnName: 'setsockopt'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_shutdown; fnName: 'shutdown'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_socket; fnName: 'socket'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_gethostbyaddr; fnName: 'gethostbyaddr'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_gethostbyname; fnName: 'gethostbyname'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_gethostname; fnName: 'gethostname'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getservbyport; fnName: 'getservbyport'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getservbyname; fnName: 'getservbyname'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_getprotobynumber; fnName: 'getprotobynumber'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_getprotobyname; fnName: 'getprotobyname'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_WSAStartup; fnName: 'WSAStartup'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_WSACleanup; fnName: 'WSACleanup'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_WSASetLastError; fnName: 'WSASetLastError'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook_WSAGetLastError; fnName: 'WSAGetLastError'; fnModule: WINSOCKLIB),
    (fnOrig : nil; fnNew: @Hook___WSAFDIsSet; fnName: '__WSAFDIsSet'; fnModule: WINSOCKLIB),

    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetHostByName; fnName: 'WSAAsyncGetHostByName'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_getaddrinfo; fnName: 'getaddrinfo'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_freeaddrinfo; fnName: 'freeaddrinfo'; fnModule: 'ws2_32.dll'),

    (fnOrig : nil; fnNew: @Hook_WSARecv; fnName: 'WSARecv'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSARecvFrom; fnName: 'WSARecvFrom'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASend; fnName: 'WSASend'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASendTo; fnName: 'WSASendTo'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAAsyncSelect; fnName: 'WSAAsyncSelect'; fnModule: 'ws2_32.dll'),

    (fnOrig : nil; fnNew: @Hook_WSAConnect; fnName: 'WSAConnect'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASocketA; fnName: 'WSASocketA'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASocketW; fnName: 'WSASocketW'; fnModule: 'ws2_32.dll'),

    // Actually here function for Winsock v2.0, which cannot exists in Win95 where winsock is 1.1
    // And these functions are not mandatory

    (fnOrig : nil; fnNew: @Hook_WSAIsBlocking; fnName: 'WSAIsBlocking'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAUnhookBlockingHook; fnName: 'WSAUnhookBlockingHook'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASetBlockingHook; fnName: 'WSASetBlockingHook'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSACancelBlockingCall; fnName: 'WSACancelBlockingCall'; fnModule: 'ws2_32.dll'),
{    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetServByName; fnName: 'WSAAsyncGetServByName'),

    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetServByPort; fnName: 'WSAAsyncGetServByPort'),
    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetProtoByName; fnName: 'WSAAsyncGetProtoByName'),
    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetProtoByNumber; fnName: 'WSAAsyncGetProtoByNumber'),
    (fnOrig : nil; fnNew: @Hook_WSAAsyncGetHostByAddr; fnName: 'WSAAsyncGetHostByAddr'),
}
    (fnOrig : nil; fnNew: @Hook_WSACancelAsyncRequest; fnName: 'WSACancelAsyncRequest'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAAccept; fnName: 'WSAAccept'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSACloseEvent; fnName: 'WSACloseEvent'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSAConnect; fnName: 'WSAConnect'),

    (fnOrig : nil; fnNew: @Hook_WSACreateEvent; fnName: 'WSACreateEvent'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSADuplicateSocketA; fnName: 'WSADuplicateSocketA'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSADuplicateSocketW; fnName: 'WSADuplicateSocketW'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAEnumNetworkEvents; fnName: 'WSAEnumNetworkEvents'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSAEnumProtocolsA; fnName: 'WSAEnumProtocolsA'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSAEnumProtocolsW; fnName: 'WSAEnumProtocolsW'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAEventSelect; fnName: 'WSAEventSelect'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAGetOverlappedResult; fnName: 'WSAGetOverlappedResult'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSAGetQosByName; fnName: 'WSAGetQOSByName'),
//    (fnOrig : nil; fnNew: @Hook_WSAhtonl; fnName: 'WSAHtonl'),
//    (fnOrig : nil; fnNew: @Hook_WSAhtons; fnName: 'WSAHtons'),
    (fnOrig : nil; fnNew: @Hook_WSAIoctl; fnName: 'WSAIoctl'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSAJoinLeaf; fnName: 'WSAJoinLeaf'),
//    (fnOrig : nil; fnNew: @Hook_WSANtohl; fnName: 'WSANtohl'),
//    (fnOrig : nil; fnNew: @Hook_WSANtohs; fnName: 'WSANtohs'),

    (fnOrig : nil; fnNew: @Hook_WSARecvDisconnect; fnName: 'WSARecvDisconnect'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSAResetEvent; fnName: 'WSAResetEvent'; fnModule: 'ws2_32.dll'),

    (fnOrig : nil; fnNew: @Hook_WSASendDisconnect; fnName: 'WSASendDisconnect'; fnModule: 'ws2_32.dll'),
    (fnOrig : nil; fnNew: @Hook_WSASetEvent; fnName: 'WSASetEvent'; fnModule: 'ws2_32.dll'),
//    (fnOrig : nil; fnNew: @Hook_WSASocketA; fnName: 'WSASocketA'),
//    (fnOrig : nil; fnNew: @Hook_WSASocketW; fnName: 'WSASocketW'),

    (fnOrig : nil; fnNew: @Hook_WSAWaitForMultipleEvents; fnName: 'WSAWaitForMultipleEvents'; fnModule: 'ws2_32.dll')
{    (fnOrig : nil; fnNew: @Hook_WSAAddressToStringA; fnName: 'WSAAddressToStringA'),
    (fnOrig : nil; fnNew: @Hook_WSAAddressToStringW; fnName: 'WSAAddressToStringW'),
    (fnOrig : nil; fnNew: @Hook_WSAStringToAddressA; fnName: 'WSAStringToAddressA'),
    (fnOrig : nil; fnNew: @Hook_WSAStringToAddressW; fnName: 'WSAStringToAddressW'),

    (fnOrig : nil; fnNew: @Hook_WSALookupServiceBeginA; fnName: 'WSALookupServiceBeginA'),
    (fnOrig : nil; fnNew: @Hook_WSALookupServiceBeginW; fnName: 'WSALookupServiceBeginW'),
    (fnOrig : nil; fnNew: @Hook_WSALookupServiceNextA; fnName: 'WSALookupServiceNextA'),
    (fnOrig : nil; fnNew: @Hook_WSALookupServiceNextW; fnName: 'WSALookupServiceNextW'),
    (fnOrig : nil; fnNew: @Hook_WSALookupServiceEnd; fnName: 'WSALookupServiceEnd'),

    (fnOrig : nil; fnNew: @Hook_WSAInstallServiceClassA; fnName: 'WSAInstallServiceClassA'),
    (fnOrig : nil; fnNew: @Hook_WSAInstallServiceClassW; fnName: 'WSAInstallServiceClassW'),
    (fnOrig : nil; fnNew: @Hook_WSARemoveServiceClass; fnName: 'WSARemoveServiceClass'),
    (fnOrig : nil; fnNew: @Hook_WSAGetServiceClassInfoA; fnName: 'WSAGetServiceClassInfoA'),
    (fnOrig : nil; fnNew: @Hook_WSAGetServiceClassInfoW; fnName: 'WSAGetServiceClassInfoW'),

    (fnOrig : nil; fnNew: @Hook_WSAEnumNameSpaceProvidersA; fnName: 'WSAEnumNameSpaceProvidersA'),
    (fnOrig : nil; fnNew: @Hook_WSAEnumNameSpaceProvidersW; fnName: 'WSAEnumNameSpaceProvidersW'),
    (fnOrig : nil; fnNew: @Hook_WSAGetServiceClassNameByClassIdA; fnName: 'WSAGetServiceClassNameByClassIdA'),
    (fnOrig : nil; fnNew: @Hook_WSAGetServiceClassNameByClassIdW; fnName: 'WSAGetServiceClassNameByClassIdW'),
    (fnOrig : nil; fnNew: @Hook_WSASetServiceA; fnName: 'WSASetServiceA'),

    (fnOrig : nil; fnNew: @Hook_WSASetServiceW; fnName: 'WSASetServiceW'),
    (fnOrig : nil; fnNew: @Hook_WSAProviderConfigChange; fnName: 'WSAProviderConfigChange')
}
     );

implementation
uses hook, hook_func, helpwnd;

var
   has_sent : Boolean = False;
   last_connect: integer = -1;

function Hook_accept(const s: TSocket; var addr: TSockAddr; var addrlen: Integer): TSocket; stdcall;
begin
     Log(LOG_LEVEL_CONN, 'accept',[]);

     if (ProxyArray.Exists(s)) and (ProxyArray.Items[s].Method = METHOD_BIND) then
     begin
          ProxyArray.Items[s].Proxy.Accept(addr);
          addrlen := SizeOf(TSockAddr);
          result := s;
     end
     else
         result := accept(s, addr, addrlen);
end;

function Hook_bind(const s: TSocket; const addr: PSockAddr; const namelen: Integer ): Integer; stdcall;
begin
     result := bind(s, addr, namelen);
     Log(LOG_LEVEL_CONN, 'binding to (%s, %d) = %d...',[GetDottedIP(addr^.sin_addr.S_addr), ntohs(addr^.sin_port), result]);
end;

function Hook_getsockname( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer; stdcall;
begin
     result := getsockname(s, name, namelen);
     Log(LOG_LEVEL_CONN, 'getsockname (%s:%d)',[GetDottedIP(Name.sin_addr.S_addr), ntohs(Name.sin_port)]);
end;


function Hook_listen(s: TSocket; backlog: Integer): Integer; stdcall;
begin
     if ProxyArray.Exists(s) and (ProxyArray.Items[s].Method = METHOD_BIND) then
     begin
          result := 0;
     end
     else
         result := listen(s, backlog);
     Log(LOG_LEVEL_CONN, 'listen backlog = %d, result = %d',[backlog, result]);
end;


function Hook_closesocket( const s: TSocket ): Integer; stdcall;
begin
     if ProxyArray.Exists(s) and (ProxyArray.Items[s].Method = METHOD_BIND) then
        result := 0
     else
     begin
          result := closesocket(s);
          ProxyArray.Del(s);
          if last_connect = integer(s) then
             last_connect := -1;
     end;

     Log(LOG_LEVEL_CONN, 'closesocket %d',[s]);
end;

function Hook_connect(const s: TSocket; const name: PSockAddr; namelen: Integer): Integer; stdcall;
var
   HostEnt  : PHostEnt;
   ph       : PHostAddr;
   oldName  : TSockAddr;
   res      : integer;
   FirstSocksServ: string;
   FirstSocksPort: integer;
   idx, err : integer;
   Item     : TProxyItem;
   hMutex   : THandle;

   procedure ReleaseMutexHandle();
   var
      lastErr, lastErr2: Integer;
   begin
        lastErr2 := GetLastError();
        lastErr := WSAGetLastError();

        ReleaseMutex(hMutex);
        CloseHandle(hMutex);

        WSASetLastError(lastErr);
        SetLastError(lastErr2);
   end;
begin
     hMutex := CreateMutex(nil, True, SYNC_CONNECT_MUTEX);
     last_connect := -1;

     Log(LOG_LEVEL_CONN, 'connecting to (%s, %d)...',[GetAddrString(name.sin_addr.S_addr), ntohs(name.sin_port)]);


     if DirectAddr.IsAddrDirect(name.sin_addr.S_addr) or (DirectAddr.IsPortDirect(name.sin_port)) then
     begin
          Item := ProxyArray.GetItem(s);
          if (Item <> nil) then
          begin
               if (Item.Method = METHOD_UDP) then
                 ProxyArray.Del(s)
               else
                 Item.State := psDirect;
          end;

          ReleaseMutexHandle();
          WSASetLastError(0);
          result := connect(s, name, namelen);
          Log(LOG_LEVEL_CONN, 'Direct connection to (%s, %d) = %d',[GetAddrString(name.sin_addr.S_addr), ntohs(name.sin_port), result]);
          exit;
     end;

     oldName := Name^;
     Item := ProxyArray.GetItem(s);

     if (Item <> nil) and (Item.Method = METHOD_UDP) then
     begin
          Item.OrigName := oldName;
//          Item.BindName := oldName;
     end;

     if (Item <> nil) and (Item.Method <> METHOD_UDP) then
     begin
          idx := SocksChains.GetFirstIndex();

          if idx = SocksChains.Count then
          begin
               result := -1;
               WSASetLastError(WSAECONNREFUSED);
               Log(LOG_LEVEL_SOCKS, 'end of chain reached...',[]);
               ReleaseMutexHandle();
               exit;
          end;

          FirstSocksServ := SocksChains[idx].Server;
          FirstSocksPort := SocksChains[idx].Port;

          HostEnt := gethostbyname(PChar(FirstSocksServ));
          if HostEnt = nil then
          begin
               DisplayMessage(Format('SOCKS server %s not found. No DNS records',[FirstSocksServ]));
               ProxyArray.Del(s);
               result := connect(s, name, namelen);
               ReleaseMutexHandle();
               exit;
          end;
          ph := PHostAddr(HostEnt^.h_addr_list^);
          name.sin_addr.S_addr := Cardinal(ph^);
          name.sin_port := ntohs(FirstSocksPort);

          result := connect(s, name, namelen);
          err := 0;
          if (result = -1) or (result = 0) then
          begin
               if (result = -1) then
                 err := WSAGetLastError();

               if (err = WSAEWOULDBLOCK) or (err = 0) then
               begin
                    Item.OrigName := oldName;
//                    Item.BindName := oldName;
                    Item.Method := METHOD_CONNECT;
                    //* Thread was created in the suspend mode
                    //*
                    Item.Resume;
                    //* We should wait until connection to SOCKS server
                    //* will be established. It is bad but some programs
                    //* doesn't process WSAEWOULDBLOCK for waiting connection by
                    //* select'ing socket.
                    //*
                    if not Item.Blocking then
                    begin
                         Log(LOG_LEVEL_WARN, 'Socket %d in non-blocking mode',[s]);
                         result := -1;
                         WSASetLastError(WSAEWOULDBLOCK);
                    end
                    else
                    begin
                         Log(LOG_LEVEL_WARN, 'Socket %d in blocking mode',[s]);

                         res := Item.WaitFor();
                         if res <> 0 then
                         begin
                              result := -1;
                              WSASetLastError(WSAECONNREFUSED);
                              ReleaseMutexHandle();
                              exit;
                         end;

                         WSASetLastError(0);
                         result := 0;

                         last_connect := s;
                     end;
               end
               else
               begin
                    if (err = WSAECONNREFUSED) or (err = WSAECONNRESET) then
                      DisplayMessage(Format('Error connecting to the SOCKS server (%s:%d)'#13#10'Winsock error: %s (%d)',[FirstSocksServ, FirstSocksPort, WSocketErrorDesc(WSAGetLastError()), WSAGetLastError()]));
                    Log(LOG_LEVEL_WARN, 'connect()  error: %s (%d)',[WSocketErrorDesc(err), err]);
               end;
          end;
     end
     else if (Item <> nil) and (Item.Method = METHOD_UDP) then
     begin
          TSOCKS5Proxy(Item.Proxy).DoConnectUDP();
          TSOCKS5Proxy(Item.Proxy).NegotiateUDP();
          TSOCKS5Proxy(Item.Proxy).DoOpenUDP();
          WSASetLastError(0);
          result := 0;
     end
     else
         result := connect(s, name, namelen);

     Log(LOG_LEVEL_CONN, 'connect (%s, %d) = %d',[GetAddrString(oldName.sin_addr.S_addr), ntohs(oldName.sin_port), result]);
     ReleaseMutexHandle();
end;

function Hook_ioctlsocket( const s: TSocket; const cmd: DWORD; var arg: u_long ): Integer; stdcall;
var
   str: string;
   Item: TProxyItem;
begin
     case cmd of
       FIONBIO: begin
                     str := 'Nonblocking mode';
                     if arg > 0 then
                       str := str + ' enable'
                     else
                       str := str + ' disable';
                     Item := ProxyArray.GetItem(s);
                     if (Item <> nil) then
                        Item.Blocking := not (arg > 0); //False;
                end;
       FIONREAD: str := 'FIONREAD';
       SIOCATMARK: str := 'SIOCATMARK';
     end;
     result := ioctlsocket(s, cmd, arg);
     Log(LOG_LEVEL_CONN, 'ioctlsocket (%s)',[str]);
end;

function Hook_getpeername( const s: TSocket; var name: TSockAddr; var namelen: Integer ): Integer; stdcall;
var
   Item: TProxyItem;
begin
     result := getpeername(s, name, namelen);
     Item := ProxyArray.GetItem(s);
     if (Item <> nil) and (result = 0) then
     begin
          Move(Item.OrigName, name, SizeOf(Item.OrigName));
     end;
     Log(LOG_LEVEL_CONN, 'getpeername = %s',[GetFullAddr(name)]);
end;


function Hook_getsockopt( const s: TSocket; const level, optname: Integer; optval: PChar; var optlen: Integer ): Integer; stdcall;
begin
     result := getsockopt(s, level, optname, optval, optlen);
     Log(LOG_LEVEL_CONN, 'getsockopt (%d) = %s',[s, GetSockOpts(optname)]);
end;

function Hook_htonl(hostlong: u_long): u_long; stdcall;
begin
     result := htonl(hostlong);
end;

function Hook_htons(hostshort: u_short): u_short; stdcall;
begin
     result := htons(hostshort);
end;

function Hook_inet_addr(cp: PChar): u_long; stdcall;
begin
     result := inet_addr(cp);
end;

function Hook_inet_ntoa(inaddr: TInAddr): PChar; stdcall;
begin
     result := inet_ntoa(inaddr);
end;


function Hook_ntohl(netlong: u_long): u_long; stdcall;
begin
     result := ntohl(netlong);
end;

function Hook_ntohs(netshort: u_short): u_short; stdcall;
begin
     result := ntohs(netshort);
end;

function Hook_recv(s: TSocket; Buf: Pointer; len, flags: Integer): Integer; stdcall;
var
   buffer: array[0..65535] of char;
   from: TSockAddrIn;
   fromlen: integer;
   Item : TProxyItem;
begin
     Item := ProxyArray.GetItem(s);

     if (Item = nil) or ((Item <> nil) and (Item.State = psDirect)) then
     begin
          result := recv(s, buf, len, flags);
          exit;
     end;

     if (Item <> nil) and (not Item.Blocking) and (not (Item.State in [psEstablished, psError])) then
     begin
          Item.WaitFor;
//          Log(LOG_LEVEL_CONN, '[%d] pending recv ', [s]);
          result := -1;
          WSASetLastError(WSAEWOULDBLOCK);
          exit;
     end
     else
     begin
          WSASetLastError(0);
     end;
{
     if (flags and MSG_PEEK) <> 0 then
       flags := flags and (not MSG_PEEK);
}
     if (Item <> nil) and (Item.Method = METHOD_UDP) then
     begin
          from := Item.Proxy.DestAddr;
          fromlen := SizeOf(TSockAddrIn);
          Log(LOG_LEVEL_CONN, 'UDP recv(socket = %d; len = %d; from = %s:%d)', [s, len, GetDottedIP(from.sin_addr.s_addr), ntohs(from.sin_port)]);
          result := recvfrom(s, @buffer, len + 10, flags, from, fromlen);

          if result > 10 then
          begin
               Move(buffer[10], Buf^, result - 10);
               dec(result, 10);
               exit;
          end;
     end
     else
         result := recv(s, @buffer, len, flags);

     Log(LOG_LEVEL_CONN, 'recv(socket = %d; lenght = %d; flags = %d) = %d', [s, len, flags, result]);

     if result > 0 then
     begin
          if (Item <> nil) and (Item.Method = METHOD_UDP) then
          begin
               Log(LOG_LEVEL_CONN, 'recv(socket = %d) in ProxyArray', [s]);

               if result > 10 then
               begin
                    Move(buffer[10], Buf^, result - 10);
                    dec(result, 10);
                    exit;
               end;
          end;

          RawLog(s, @buffer, result, tkRecv);
{
          if (Item <> nil) and (Item.Method <> METHOD_UDP) then
            result := PluginDisp.InvokeRecv(GetProcessName(GetCurrentProcessId), Item.OrigName.sin_addr.S_addr, Item.OrigName.sin_port, @buffer, result);
}
          Move(buffer[0], Buf^, result);
     end;
end;

function Hook_recvfrom(s: TSocket; Buf: Pointer; len, flags: Integer; var from: TSockAddr; var fromlen: Integer): Integer; stdcall;
var
   buffer: array[0..65535] of char;
   udp_addr: TSockAddrIn;
   Item : TProxyItem;
begin
     Item := ProxyArray.GetItem(s);

     if (Item <> nil) and (Item.Method = METHOD_UDP) then
     begin
          udp_addr := Item.Proxy.DestAddr;
          result := recvfrom(s, @buffer, len + 10, flags, udp_addr, fromlen);
          if result >= 0 then
            Log(LOG_LEVEL_CONN, 'recvfrom(socket = %d; length = %d; flags = %d; from = %s:%d; fromlen = %d) = %d',[s, len, flags, GetDottedIP(udp_addr.sin_addr.S_addr), htons(udp_addr.sin_port), fromlen, result]);
     end
     else
     begin
          result := recvfrom(s, @buffer, len, flags, from, fromlen);
          if result >= 0 then
            Log(LOG_LEVEL_CONN, 'recvfrom(socket = %d; length = %d; flags = %d; from = %s:%d; fromlen = %d) = %d',[s, len, flags, GetDottedIP(from.sin_addr.S_addr), htons(from.sin_port), fromlen, result]);
     end;


     if result >= 0 then
     begin
          if (Item <> nil) and (Item.Method = METHOD_UDP) then
          begin
               Log(LOG_LEVEL_CONN, 'recvfrom(socket = %d) in ProxyArray', [s]);

               assert(result > 10);
               from.sin_family := AF_INET;
               from.sin_addr.S_addr := PDWORD(@Buffer[4])^;
               from.sin_port := PWORD(@Buffer[8])^;
               fromlen := SizeOf(TSockAddrIn);

               Move(buffer[10], Buf^, result - 10);
               dec(result, 10);
               RawLog(s, @buffer[10], result, tkRecv);

               exit;
          end;

          RawLog(s, @buffer, result, tkRecv);
          Move(buffer[0], Buf^, result);
     end;

end;

function Hook_select(nfds: Integer; readfds, writefds, exceptfds: PFDSet; timeout: PTimeVal): Integer; stdcall;
{var
   i: integer;
   Item : TProxyItem;
}
begin
     result := select(nfds, readfds, writefds, exceptfds, timeout);
{     if writefds <> nil then
     begin
          for i:=0 to writefds^.fd_count - 1 do
          begin
               Item := ProxyArray.GetItem(writefds^.fd_array[i]);
               if (Item <> nil) and (Item.State <> psEstablished) and (Item.State <> psError) then
                 dec(result);
          end;
          if result < 0 then
             result := 0;
     end;
}
     Log(LOG_LEVEL_CONN, 'select() = %d',[result]);
end;

function Hook_send(s: TSocket; Buf: Pointer; len, flags: Integer): Integer; stdcall;
var
   buffer: array[0..65535] of char;
   addrto: TSockAddr;
   tolen: integer;
   Item: TProxyItem;
   origLen: Integer;
begin
     Item := ProxyArray.GetItem(s);

     if (Item = nil) or ((Item <> nil) and (Item.State = psDirect)) then
     begin
          result := send(s, buf, len, flags);
          exit;
     end;

     if (Item <> nil) and (not Item.Blocking) and (not (Item.State in [psEstablished, psError])) then
     begin
          Item.WaitFor();
          result := -1;
          WSASetLastError(WSAEWOULDBLOCK);
          exit;
     end
     else
     begin
          WSASetLastError(0);
     end;

     origLen := len;
{
     if (Item <> nil) and (Item.Method <> METHOD_UDP) then
       len := PluginDisp.InvokeSend(GetProcessName(GetCurrentProcessId), Item.OrigName.sin_addr.S_addr, Item.OrigName.sin_port, Pointer(Buf), len);
}
     Move(Buf^, buffer[0], len);

     if (Item <> nil) and (Item.Method = METHOD_UDP) then
     begin
          ZeroMemory(@addrto, SizeOf(addrto));
          addrto := Item.OrigName;
          tolen := SizeOf(Item.OrigName);
          result := Item.Proxy.Sendto(s, buf, len, 0, addrto, tolen);
          Log(LOG_LEVEL_CONN, 'UDP send(socket = %d; lenght = %d; flags = %d) = %d',[s, len, flags, result]);
     end
     else
     begin
          result := send(s, @buffer, len, flags);

          if result <> origLen then
             result := origLen;
          Log(LOG_LEVEL_CONN, 'send(socket = %d; lenght = %d; flags = %d) = %d',[s, len, flags, result]);
     end;

     if result > 0 then
     begin
          RawLog(s, @buffer, result, tkSend);
     end;

end;

function Hook_sendto(s: TSocket; Buf: Pointer; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer; stdcall;
var
   buffer: array[0..65535] of char;
   Item : TProxyItem;
   res : integer;
begin
     Move(Buf^, buffer[0], len);

     if ProxyArray.Exists(s) and (ProxyArray.Items[s].Method = METHOD_UDP) then
     begin
          Item := ProxyArray.Items[s];

          if Item.State <> psEstablished then
          begin
               Log(LOG_LEVEL_CONN, 'Establishing tunnel...', []);
               TSOCKS5Proxy(Item.Proxy).DoConnectUDP;
               res := TSOCKS5Proxy(Item.Proxy).NegotiateUDP;
               if res = 0 then
                 Item.State := psEstablished;

//               Item.Resume;
//               Item.WaitFor();
          end;

          Log(LOG_LEVEL_CONN, 'sendto(socket = %d) in ProxyArray', [s]);
          result := Item.Proxy.Sendto(s, buf, len, flags, addrto, tolen);
     end
     else
       result := sendto(s, buf, len, flags, addrto, tolen);

     Log(LOG_LEVEL_CONN, 'sendto(socket = %d; length = %d; flags = %d; to = %s:%d) = %d',[s, len, flags, GetDottedIP(addrto.sin_addr.S_addr), htons(addrto.sin_port), result]);
     if result >= 0 then
     begin
          RawLog(s, @buffer, result, tkSend);
     end;
end;

function Hook_setsockopt(s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer; stdcall;
begin
     result := setsockopt(s, level, optname, optval, optlen);
     Log(LOG_LEVEL_CONN, 'setsockopt(%d, %s, %d)', [s, GetSockOpts(optname), DWORD(optval)]);
end;

function Hook_shutdown(s: TSocket; how: Integer): Integer; stdcall;
begin
     result := shutdown(s, how);
     Log(LOG_LEVEL_CONN, 'shutdown',[]);
end;

function Hook_socket( const af, struct, protocol: Integer ): TSocket; stdcall;
var
   s: string;
begin
     result := socket(af, struct, protocol);

     if Unloaded then exit;

     case struct of
       SOCK_STREAM: s := 'tcp';
       SOCK_DGRAM: s := 'udp';
     else
       s := 'Unknown';
     end;
     Log(LOG_LEVEL_CONN, 'socket(%s) = %d',[s, result]);

     if ((struct = SOCK_STREAM) or (struct = SOCK_DGRAM)) and (result <> INVALID_SOCKET) then
     begin
          if (struct = SOCK_DGRAM) and (SocksChains.GetLastSOCKS5() = nil) then
          begin
               Log(LOG_LEVEL_WARN, 'No SOCKS5 servers found at the end of the chain. UDP traversing supported only by SOCKS v5 related servers.',[]);
               exit;
          end;
          // Add only TCP or UDP sockets
          if not ProxyArray.Exists(result) then
            ProxyArray.Add(result, af, struct, protocol);
     end;

end;

function Hook_gethostbyaddr(addr: Pointer; len, struct: Integer): PHostEnt; stdcall;
begin
     result := gethostbyaddr(addr, len, struct);
     Log(LOG_LEVEL_CONN, 'gethostbyaddr',[]);
end;



function Hook_gethostname(name: PChar; len: Integer): Integer; stdcall;
begin
     result := gethostname(name, len);
     Log(LOG_LEVEL_CONN, 'gethostname = %s', [name]);
end;

function Hook_getservbyport(port: Integer; proto: PChar): PServEnt; stdcall;
begin
     result := getservbyport(port, proto);
     Log(LOG_LEVEL_CONN, 'getservbyport',[]);
end;

function Hook_getservbyname(const name, proto: PChar): PServEnt; stdcall;
begin
     result := getservbyname(name, proto);
     Log(LOG_LEVEL_CONN, 'getservbyname',[]);
end;

function Hook_getprotobynumber(const proto: Integer): PProtoEnt; stdcall;
begin
     result := getprotobynumber(proto);
     Log(LOG_LEVEL_CONN, 'getprotobynumber',[]);
end;

function Hook_getprotobyname(const name: PChar): PProtoEnt; stdcall;
begin
     result := getprotobyname(name);
     Log(LOG_LEVEL_CONN, 'getprotobyname',[]);
end;

function Hook_WSAStartup(wVersionRequired: word; var WSData: TWSAData): Integer; stdcall;
begin
     result := WSAStartup(wVersionRequired, WSData);

     Log(LOG_LEVEL_CONN, 'WSAStartup (%d): ',[wVersionRequired]);
     Log(LOG_LEVEL_CONN, '     wVersion       : %d',[WSData.wVersion]);
     Log(LOG_LEVEL_CONN, '     wHighVersion   : %d',[WSData.wHighVersion]);
     Log(LOG_LEVEL_CONN, '     szDescription  : %s',[WSData.szDescription]);
     Log(LOG_LEVEL_CONN, '     szSystemStatus : %s',[WSData.szSystemStatus]);
     Log(LOG_LEVEL_CONN, '     iMaxSockets    : %d',[WSData.iMaxSockets]);
     Log(LOG_LEVEL_CONN, '     iMaxUdpDg      : %d',[WSData.iMaxUdpDg]);
end;

function Hook_WSACleanup: Integer; stdcall;
begin
     result := WSACleanup();
     Log(LOG_LEVEL_CONN, 'WSACleanup',[]);
end;

procedure Hook_WSASetLastError(iError: Integer); stdcall;
begin
     WSASetLastError(iError);
     Log(LOG_LEVEL_CONN, 'WSASetLastError(%d)',[iError]);
end;

function Hook_WSAGetLastError: Integer; stdcall;
begin
     result := WSAGetLastError();
     if (result <> WSAEWOULDBLOCK) then
       Log(LOG_LEVEL_CONN, 'WSAGetLastError = %d',[result]);
end;

function Hook_WSAIsBlocking: BOOL; stdcall;
begin
     result := WSAIsBlocking();
     Log(LOG_LEVEL_CONN, 'WSAIsBlocking',[]);
end;

function Hook_WSAUnhookBlockingHook: Integer; stdcall;
begin
     result := WSAUnhookBlockingHook();
     Log(LOG_LEVEL_CONN, 'WSAUnhookBlockingHook',[]);
end;

function Hook_WSASetBlockingHook(lpBlockFunc: TFarProc): TFarProc; stdcall;
begin
     result := WSASetBlockingHook(lpBlockFunc);
     Log(LOG_LEVEL_CONN, 'WSASetBlockingHook',[]);
end;

function Hook_WSACancelBlockingCall: Integer; stdcall;
begin
     result := WSACancelBlockingCall();
     Log(LOG_LEVEL_CONN, 'WSACancelBlockingCall',[]);
end;

function Hook_WSAAsyncGetServByName(HWindow: HWND; wMsg: u_int; name, proto, buf: PChar; buflen: Integer): THandle; stdcall;
begin
     result := WSAAsyncGetServByName(HWindow, wMsg, name, proto, buf, buflen);
     Log(LOG_LEVEL_CONN, 'WSAAsyncGetServByName',[]);
end;

function Hook_WSAAsyncGetServByPort(HWindow: HWND; wMsg, port: u_int; proto, buf: PChar; buflen: Integer): THandle; stdcall;
begin
     result := WSAAsyncGetServByPort(HWindow, wMsg, port, proto, buf, buflen);
     Log(LOG_LEVEL_CONN, 'WSAAsyncGetServByPort',[]);
end;

function Hook_WSAAsyncGetProtoByName(HWindow: HWND; wMsg: u_int; name, buf: PChar; buflen: Integer): THandle; stdcall;
begin
     result := WSAAsyncGetProtoByName(HWindow, wMsg, name, buf, buflen);
     Log(LOG_LEVEL_CONN, 'WSAAsyncGetProtoByName',[]);
end;

function Hook_WSAAsyncGetProtoByNumber(HWindow: HWND; wMsg: u_int; number: Integer; buf: PChar; buflen: Integer): THandle; stdcall;
begin
     result := WSAAsyncGetProtoByNumber(HWindow, wMsg, number, buf, buflen);
     Log(LOG_LEVEL_CONN, 'WSAAsyncGetProtoByNumber',[]);
end;


function Hook_WSAAsyncGetHostByAddr(HWindow: HWND; wMsg: u_int; addr: PChar; len, struct: Integer; buf: PChar; buflen: Integer): THandle; stdcall;
begin
     result := WSAAsyncGetHostByAddr(HWindow, wMsg, addr, len, struct, buf, buflen);
     Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByAddr',[]);
end;

function Hook_WSACancelAsyncRequest(hAsyncTaskHandle: THandle): Integer; stdcall;
begin
     result := WSACancelAsyncRequest(hAsyncTaskHandle);
     Log(LOG_LEVEL_CONN, 'WSACancelAsyncRequest',[]);
end;

function Hook_WSAAsyncSelect(s: TSocket; HWindow: HWND; wMsg: u_int; lEvent: Longint): Integer; stdcall;
var
   Item: TProxyItem;
begin
     Item := ProxyArray.GetItem(s);

     if (Item <> nil) and ((FD_CONNECT and lEvent) = FD_CONNECT) then
     begin
          result := 0;
          Item.SetFireEvent(lEvent, HWindow, wMsg);
     end
     else if (Item <> nil) and (wMsg = 0) and (lEvent = 0) then
     begin
          result := 0;
          Item.ClearFireEvent();
     end
     else
         result := WSAAsyncSelect(s, HWindow, wMsg, lEvent);
     Log(LOG_LEVEL_CONN, 'WSAAsyncSelect(s = %d; HWindow = %d; wMsg = %d; lEvent = %d) = %d',[s, HWindow, wMsg, lEvent, result]);
end;

function Hook___WSAFDIsSet(s: TSOcket; var FDSet: TFDSet): Bool; stdcall;
begin
     result := __WSAFDIsSet(s, FDSet);
//     Log(LOG_LEVEL_CONN, '__WSAFDIsSet (%d) = %d',[s, integer(result)]);
end;


function Hook_WSAAccept( s : TSocket; addr : TSockAddr; addrlen : PInteger; lpfnCondition : LPCONDITIONPROC; dwCallbackData : DWORD ): TSocket; stdcall;
begin
     result := WSAAccept(s, addr, addrlen, lpfnCondition, dwCallbackData);
     Log(LOG_LEVEL_CONN, 'WSAAccept',[]);
end;

function Hook_WSACloseEvent(hEvent : WSAEVENT) : WordBool; stdcall;
begin
     result := WSACloseEvent(hEvent);
     Log(LOG_LEVEL_CONN, 'WSACloseEvent',[]);
end;

function Hook_WSAConnect( s : TSocket; const name : PSockAddr; namelen : Integer; lpCallerData,lpCalleeData : LPWSABUF; lpSQOS,lpGQOS : LPQOS ) : Integer; stdcall;
begin
     result := WSAConnect(s, name, namelen, lpCallerData, lpCalleeData, lpSQOS, lpGQOS);
     Log(LOG_LEVEL_CONN, 'WSAConnect(%d,%p,%p)',[s, lpCallerData[0], lpCalleeData[0]]);
end;

function Hook_WSACreateEvent : WSAEVENT; stdcall;
begin
     result := WSACreateEvent();
     Log(LOG_LEVEL_CONN, 'WSACreateEvent',[]);
end;

function Hook_WSADuplicateSocketA( s : TSocket; dwProcessId : DWORD; lpProtocolInfo : LPWSAProtocol_InfoA ) : Integer; stdcall;
begin
     result := WSADuplicateSocketA(s, dwProcessId, lpProtocolInfo);
     Log(LOG_LEVEL_CONN, 'WSADuplicateSocketA',[]);
end;

function Hook_WSADuplicateSocketW( s : TSocket; dwProcessId : DWORD; lpProtocolInfo : LPWSAProtocol_InfoW ) : Integer; stdcall;
begin
     result := WSADuplicateSocketW(s, dwProcessId, lpProtocolInfo);
     Log(LOG_LEVEL_CONN, 'WSADuplicateSocketW',[]);
end;

function Hook_WSAEnumNetworkEvents( const s : TSocket; const hEventObject : WSAEVENT; lpNetworkEvents : LPWSANETWORKEVENTS ) :Integer; stdcall;
begin
     result := WSAEnumNetworkEvents(s, hEventObject, lpNetworkEvents);
     Log(LOG_LEVEL_CONN, 'WSAEnumNetworkEvents',[]);
end;

function Hook_WSAEnumProtocolsA( lpiProtocols : PInteger; lpProtocolBuffer : LPWSAProtocol_InfoA; var lpdwBufferLength : DWORD ) : Integer; stdcall;
begin
     result := WSAEnumProtocolsA(lpiProtocols, lpProtocolBuffer, lpdwBufferLength);
     Log(LOG_LEVEL_CONN, 'WSAEnumProtocolsA',[]);
end;

function Hook_WSAEnumProtocolsW( lpiProtocols : PInteger; lpProtocolBuffer : LPWSAProtocol_InfoW; var lpdwBufferLength : DWORD ) : Integer; stdcall;
begin
     result := WSAEnumProtocolsW(lpiProtocols, lpProtocolBuffer, lpdwBufferLength);
     Log(LOG_LEVEL_CONN, 'WSAEnumProtocolsW',[]);
end;

function Hook_WSAEventSelect( s : TSocket; hEventObject : WSAEVENT; lNetworkEvents : LongInt ): Integer; stdcall;
begin
     result := WSAEventSelect(s, hEventObject, lNetworkEvents);
     Log(LOG_LEVEL_CONN, 'WSAEventSelect',[]);
end;

function Hook_WSAGetOverlappedResult( s : TSocket; lpOverlapped : LPWSAOVERLAPPED; lpcbTransfer : LPDWORD; fWait : BOOL; var lpdwFlags : DWORD ) : WordBool; stdcall;
begin
     result := WSAGetOverlappedResult(s, lpOverlapped, lpcbTransfer, fWait, lpdwFlags);
     Log(LOG_LEVEL_CONN, 'WSAGetOverlappedResult',[]);
end;

function Hook_WSAGetQosByName( s : TSocket; lpQOSName : LPWSABUF; lpQOS : LPQOS ): WordBool; stdcall;
begin
     result := WSAGetQosByName(s, lpQOSName, lpQOS);
     Log(LOG_LEVEL_CONN, 'WSAGetQosByName',[]);
end;

function Hook_WSAhtonl( s : TSocket; hostlong : u_long; var lpnetlong : DWORD ): Integer; stdcall;
begin
     result := WSAhtonl(s, hostlong, lpnetlong);
     Log(LOG_LEVEL_CONN, 'WSAhtonl',[]);
end;

function Hook_WSAhtons( s : TSocket; hostshort : u_short; var lpnetshort : WORD ): Integer; stdcall;
begin
     result := WSAhtons(s, hostshort, lpnetshort);
     Log(LOG_LEVEL_CONN, 'WSAhtons',[]);
end;

function Hook_WSAIoctl( s : TSocket; dwIoControlCode : DWORD; lpvInBuffer : Pointer; cbInBuffer : DWORD; lpvOutBuffer : Pointer; cbOutBuffer : DWORD; lpcbBytesReturned : LPDWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ) : Integer; stdcall;
begin
     result := WSAIoctl(s, dwIoControlCode, lpvInBuffer, cbInBuffer, lpvOutBuffer,  cbOutBuffer, lpcbBytesReturned, lpOverlapped,  lpCompletionRoutine);
     Log(LOG_LEVEL_CONN, 'WSAIoctl',[]);
end;

function Hook_WSAJoinLeaf( s : TSocket; name : PSockAddr; namelen : Integer; lpCallerData, lpCalleeData : LPWSABUF; lpSQOS,lpGQOS : LPQOS; dwFlags : DWORD ) : TSocket; stdcall;
begin
     result := WSAJoinLeaf(s, name, namelen, lpCallerData, lpCalleeData, lpSQOS, lpGQOS, dwFlags);
     Log(LOG_LEVEL_CONN, 'WSAJoinLeaf',[]);
end;

function Hook_WSANtohl( s : TSocket; netlong : u_long; var lphostlong : DWORD ): Integer; stdcall;
begin
     result := WSANtohl(s, netlong, lphostlong);
     Log(LOG_LEVEL_CONN, 'WSANtohl',[]);
end;

function Hook_WSANtohs( s : TSocket; netshort : u_short; var lphostshort : WORD ): Integer; stdcall;
begin
     result := WSANtohs(s, netshort, lphostshort);
     Log(LOG_LEVEL_CONN, 'WSANtohs',[]);
end;

function Hook_WSARecv( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesRecvd : DWORD; var lpFlags : DWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
var
   i, size: DWORD;
   Item: TProxyItem;
begin
     Item := ProxyArray.GetItem(s);

     if (Item <> nil) and (Item.State = psDirect) then
     begin
          result := WSARecv(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpOverlapped, lpCompletionRoutine);
          exit;
     end;

     if (Item <> nil) and (Item.State <> psEstablished)  and (Item.State <> psError) then
     begin
          result := -1;
          WSASetLastError(WSAEWOULDBLOCK);
          Log(LOG_LEVEL_CONN, '[%d] pending WSARecv', [s]);
          exit;
     end
     else
         WSASetLastError(0);

     Log(LOG_LEVEL_CONN, 'Hook_WSARecv...',[]);

     result := WSARecv(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpOverlapped, lpCompletionRoutine);

     if (lpNumberOfBytesRecvd <> 0) and (result = 0) then
     begin
          size := lpNumberOfBytesRecvd;
          for i:=0 to dwBufferCount - 1 do
          begin
               if lpBuffers[i]^.len < size then
               begin
                    RawLog(s, lpBuffers[i]^.buf, lpBuffers[i]^.len, tkRecv);
                    dec(size, lpBuffers[i]^.len);
               end
               else
               begin
                    RawLog(s, lpBuffers[i]^.buf, lpNumberOfBytesRecvd, tkRecv);
               end;
          end;
     end;

     Log(LOG_LEVEL_CONN, 'WSARecv (s = %d, dwBufferCount = %d, lpNumberOfBytesRecvd = %d) = %d',[s, dwBufferCount, lpNumberOfBytesRecvd, result]);
end;

function Hook_WSARecvDisconnect( s : TSocket; lpInboundDisconnectData : LPWSABUF ): Integer; stdcall;
begin
     result := WSARecvDisconnect(s, lpInboundDisconnectData);
     Log(LOG_LEVEL_CONN, 'WSARecvDisconnect',[]);
end;

function Hook_WSARecvFrom( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesRecvd : DWORD; var lpFlags : DWORD; lpFrom : PSockAddr; lpFromlen : PInteger; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
begin
     result := WSARecvFrom(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpFrom, lpFromlen, lpOverlapped, lpCompletionRoutine);
     Log(LOG_LEVEL_CONN, 'WSARecvFrom',[]);
end;

function Hook_WSAResetEvent( hEvent : WSAEVENT ): WordBool; stdcall;
begin
     result := WSAResetEvent(hEvent);
     Log(LOG_LEVEL_CONN, 'WSAResetEvent',[]);
end;

function Hook_WSASend( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesSent : DWORD; dwFlags : DWORD; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
var
   Item: TProxyItem;
begin
     Item := ProxyArray.GetItem(s);

     if (Item <> nil) and (Item.State = psDirect) then
     begin
          result := WSASend(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpOverlapped, lpCompletionRoutine);
          exit;
     end;

     if (Item <> nil) and (Item.State <> psEstablished)  and (Item.State <> psError) then
     begin
          result := -1;
          WSASetLastError(WSAEWOULDBLOCK);
          Log(LOG_LEVEL_CONN, '[%d] pending WSASend', [s]);

          exit;
     end
     else
         WSASetLastError(0);

     result := WSASend(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpOverlapped, lpCompletionRoutine);
     Log(LOG_LEVEL_CONN, 'WSASend',[]);
end;

function Hook_WSASendDisconnect( s : TSocket; lpOutboundDisconnectData : LPWSABUF ): Integer; stdcall;
begin
     result := WSASendDisconnect(s, lpOutboundDisconnectData);
     Log(LOG_LEVEL_CONN, 'WSASendDisconnect',[]);
end;

function Hook_WSASendTo( s : TSocket; lpBuffers : LPWSABUF; dwBufferCount : DWORD; var lpNumberOfBytesSent : DWORD; dwFlags : DWORD; lpTo : PSockAddr; iTolen : Integer; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ): Integer; stdcall;
begin
     result := WSASendTo(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpTo, iTolen, lpOverlapped, lpCompletionRoutine);
     Log(LOG_LEVEL_CONN, 'WSASendTo',[]);
end;

function Hook_WSASetEvent( hEvent : WSAEVENT ): WordBool; stdcall;
begin
     result := WSASetEvent(hEvent);
     Log(LOG_LEVEL_CONN, 'WSASetEvent',[]);
end;


function Hook_WSASocketA(af, iType, protocol : Integer; lpProtocolInfo : LPWSAProtocol_InfoA; g : GROUP; dwFlags : DWORD ): TSocket; stdcall;
var
   s: string;
   hMutex: THandle;
begin
     hMutex := OpenMutex(MUTEX_ALL_ACCESS, True, SYNC_CONNECT_MUTEX);
     result := winsock2.WSASocketA(af, iType, protocol, lpProtocolInfo, g, dwFlags);

     case iType of
       SOCK_STREAM: s := 'tcp';
       SOCK_DGRAM: s := 'udp';
     else
       s := 'Unknown';
     end;
     Log(LOG_LEVEL_CONN, 'WSASocketA(%s) = %d', [s, result]);

     if (hMutex <> 0) then
     begin
          Log(LOG_LEVEL_WARN, 'WSASocketA have opened mutex. Recursive call?', []);
          exit;
     end;

     if ((iType = SOCK_STREAM) or (iType = SOCK_DGRAM)) and (result <> INVALID_SOCKET) then
     begin
          if (iType = SOCK_DGRAM) and (SocksChains.GetLastSOCKS5() = nil) then
          begin
               Log(LOG_LEVEL_WARN, 'No SOCKS5 servers found at the end of the chain. UDP traversing supported only by SOCKS v5 related servers.',[]);
               exit;
          end;
          // Add only TCP or UDP sockets
          ProxyArray.Add(result, af, iType, protocol);
     end;

     Log(LOG_LEVEL_WARN, 'Leaving WSASocketA...', []);
end;

function Hook_WSASocketW( af, iType, protocol : Integer; lpProtocolInfo : LPWSAProtocol_InfoW; g : GROUP; dwFlags : DWORD ): TSocket; stdcall;
var
   s: string;
   hMutex: THandle;
begin
     hMutex := OpenMutex(MUTEX_ALL_ACCESS, True, SYNC_CONNECT_MUTEX);
     result := WSASocketW(af, iType, protocol, lpProtocolInfo, g, dwFlags);

     case iType of
       SOCK_STREAM: s := 'tcp';
       SOCK_DGRAM: s := 'udp';
     else
       s := 'Unknown';
     end;
     Log(LOG_LEVEL_CONN, 'WSASocketW(%s, %p, %d, %d) = %d', [s, lpProtocolInfo, g, dwFlags, result]);

     if (hMutex <> 0)  then
     begin
          Log(LOG_LEVEL_WARN, 'WSASocketW have opened mutex. Recursive call?', []);
          exit;
     end;

     if ((iType = SOCK_STREAM) or (iType = SOCK_DGRAM)) and (result <> INVALID_SOCKET) then
     begin
          if (iType = SOCK_DGRAM) and (SocksChains.GetLastSOCKS5() = nil) then
          begin
               Log(LOG_LEVEL_WARN, 'No SOCKS5 servers found at the end of the chain. UDP traversing supported only by SOCKS v5 related servers.',[]);
               exit;
          end;
          // Add only TCP or UDP sockets
          ProxyArray.Add(result, af, iType, protocol);
     end;
     Log(LOG_LEVEL_WARN, 'Leaving WSASocketW...', []);
end;


function Hook_WSAWaitForMultipleEvents( cEvents : DWORD; lphEvents : PWSAEVENT; fWaitAll : LongBool;	dwTimeout : DWORD; fAlertable : LongBool ): DWORD; stdcall;
begin
     result := WSAWaitForMultipleEvents(cEvents, lphEvents, fWaitAll, dwTimeout, fAlertable);
     Log(LOG_LEVEL_CONN, 'WSAWaitForMultipleEvents',[]);
end;

function Hook_WSAAddressToStringA( lpsaAddress : PSockAddr; const dwAddressLength : DWORD; const lpProtocolInfo : LPWSAProtocol_InfoA; const lpszAddressString : PChar; var lpdwAddressStringLength : DWORD ): Integer; stdcall;
begin
     result := WSAAddressToStringA(lpsaAddress, dwAddressLength, lpProtocolInfo, lpszAddressString, lpdwAddressStringLength);
     Log(LOG_LEVEL_CONN, 'WSAAddressToStringA',[]);
end;

function Hook_WSAAddressToStringW( lpsaAddress : PSockAddr; const dwAddressLength : DWORD; const lpProtocolInfo : LPWSAProtocol_InfoW; const lpszAddressString : PWideChar; var lpdwAddressStringLength : DWORD ): Integer; stdcall;
begin
     result := WSAAddressToStringW(lpsaAddress, dwAddressLength, lpProtocolInfo, lpszAddressString, lpdwAddressStringLength);
     Log(LOG_LEVEL_CONN, 'WSAAddressToStringW',[]);
end;

function Hook_WSAStringToAddressA( const AddressString : PChar; const AddressFamily: Integer; const lpProtocolInfo : LPWSAProtocol_InfoA; var lpAddress : TSockAddr; var lpAddressLength : Integer ): Integer; stdcall;
begin
     result := WSAStringToAddressA(AddressString, AddressFamily, lpProtocolInfo, lpAddress, lpAddressLength);
     Log(LOG_LEVEL_CONN, 'WSAStringToAddressA',[]);
end;

function Hook_WSAStringToAddressW( const AddressString : PWideChar; const AddressFamily: Integer; const lpProtocolInfo : LPWSAProtocol_InfoA; var lpAddress : TSockAddr; var lpAddressLength : Integer ): Integer; stdcall;
begin
     result := WSAStringToAddressW(AddressString, AddressFamily, lpProtocolInfo, lpAddress, lpAddressLength);
     Log(LOG_LEVEL_CONN, 'WSAStringToAddressW',[]);
end;

function Hook_WSALookupServiceBeginA( var qsRestrictions : TWSAQuerySetA; const dwControlFlags : DWORD; var hLookup : THANDLE ): Integer; stdcall;
begin
     result := WSALookupServiceBeginA(qsRestrictions, dwControlFlags, hLookup);
     Log(LOG_LEVEL_CONN, 'WSALookupServiceBeginA',[]);
end;

function Hook_WSALookupServiceBeginW( var qsRestrictions : TWSAQuerySetW; const dwControlFlags : DWORD; var hLookup : THANDLE ): Integer; stdcall;
begin
     result := WSALookupServiceBeginW(qsRestrictions, dwControlFlags, hLookup);
     Log(LOG_LEVEL_CONN, 'WSALookupServiceBeginW',[]);
end;

function Hook_WSALookupServiceNextA( const hLookup : THandle; const dwControlFlags : DWORD; var dwBufferLength : DWORD; lpqsResults : PWSAQuerySetA ): Integer; stdcall;
begin
     result := WSALookupServiceNextA(hLookup, dwControlFlags, dwBufferLength, lpqsResults);
     Log(LOG_LEVEL_CONN, 'WSALookupServiceNextA',[]);
end;

function Hook_WSALookupServiceNextW( const hLookup : THandle; const dwControlFlags : DWORD; var dwBufferLength : DWORD; lpqsResults : PWSAQuerySetW ): Integer; stdcall;
begin
     result := WSALookupServiceNextW(hLookup, dwControlFlags, dwBufferLength, lpqsResults);
     Log(LOG_LEVEL_CONN, 'WSALookupServiceNextW',[]);
end;

function Hook_WSALookupServiceEnd( const hLookup : THandle ): Integer; stdcall;
begin
     result := WSALookupServiceEnd(hLookup);
     Log(LOG_LEVEL_CONN, 'WSALookupServiceEnd',[]);
end;

function Hook_WSAInstallServiceClassA( const lpServiceClassInfo : LPWSAServiceClassInfoA ) : Integer; stdcall;
begin
     result := WSAInstallServiceClassA(lpServiceClassInfo);
     Log(LOG_LEVEL_CONN, 'WSAInstallServiceClassA',[]);
end;

function Hook_WSAInstallServiceClassW( const lpServiceClassInfo : LPWSAServiceClassInfoW ) : Integer; stdcall;
begin
     result := WSAInstallServiceClassW(lpServiceClassInfo);
     Log(LOG_LEVEL_CONN, 'WSAInstallServiceClassW',[]);
end;

function Hook_WSARemoveServiceClass( const lpServiceClassId : PGUID ) : Integer; stdcall;
begin
     result := WSARemoveServiceClass(lpServiceClassId);
     Log(LOG_LEVEL_CONN, 'WSARemoveServiceClass',[]);
end;

function Hook_WSAGetServiceClassInfoA( const lpProviderId : PGUID; const lpServiceClassId : PGUID; var lpdwBufSize : DWORD; lpServiceClassInfo : LPWSAServiceClassInfoA ): Integer; stdcall;
begin
     result := WSAGetServiceClassInfoA(lpProviderId, lpServiceClassId, lpdwBufSize, lpServiceClassInfo);
     Log(LOG_LEVEL_CONN, 'WSAGetServiceClassInfoA',[]);
end;

function Hook_WSAGetServiceClassInfoW( const lpProviderId : PGUID; const lpServiceClassId : PGUID; var lpdwBufSize : DWORD; lpServiceClassInfo : LPWSAServiceClassInfoW ): Integer; stdcall;
begin
     result := WSAGetServiceClassInfoW(lpProviderId, lpServiceClassId, lpdwBufSize, lpServiceClassInfo);
     Log(LOG_LEVEL_CONN, 'WSAGetServiceClassInfoW',[]);
end;

function Hook_WSAEnumNameSpaceProvidersA( var lpdwBufferLength: DWORD; const lpnspBuffer: LPWSANameSpace_InfoA ): Integer; stdcall;
begin
     result := WSAEnumNameSpaceProvidersA(lpdwBufferLength, lpnspBuffer);
     Log(LOG_LEVEL_CONN, 'WSAEnumNameSpaceProvidersA',[]);
end;

function Hook_WSAEnumNameSpaceProvidersW( var lpdwBufferLength: DWORD; const lpnspBuffer: LPWSANameSpace_InfoW ): Integer; stdcall;
begin
     result := WSAEnumNameSpaceProvidersW(lpdwBufferLength, lpnspBuffer);
     Log(LOG_LEVEL_CONN, 'WSAEnumNameSpaceProvidersW',[]);
end;

function Hook_WSAGetServiceClassNameByClassIdA( const lpServiceClassId: PGUID; lpszServiceClassName: PChar; var lpdwBufferLength: DWORD ): Integer; stdcall;
begin
     result := WSAGetServiceClassNameByClassIdA(lpServiceClassId, lpszServiceClassName, lpdwBufferLength);
     Log(LOG_LEVEL_CONN, 'WSAGetServiceClassNameByClassIdA',[]);
end;

function Hook_WSAGetServiceClassNameByClassIdW( const lpServiceClassId: PGUID; lpszServiceClassName: PWideChar; var lpdwBufferLength: DWORD ): Integer; stdcall;
begin
     result := WSAGetServiceClassNameByClassIdW(lpServiceClassId, lpszServiceClassName, lpdwBufferLength);
     Log(LOG_LEVEL_CONN, 'WSAGetServiceClassNameByClassIdW',[]);
end;

function Hook_WSASetServiceA( const lpqsRegInfo: LPWSAQuerySetA; const essoperation: TWSAeSetServiceOp; const dwControlFlags: DWORD ): Integer; stdcall;
begin
     result := WSASetServiceA(lpqsRegInfo, essoperation, dwControlFlags);
     Log(LOG_LEVEL_CONN, 'WSASetServiceA',[]);
end;

function Hook_WSASetServiceW( const lpqsRegInfo: LPWSAQuerySetW; const essoperation: TWSAeSetServiceOp; const dwControlFlags: DWORD ): Integer; stdcall;
begin
     result := WSASetServiceW(lpqsRegInfo, essoperation, dwControlFlags);
     Log(LOG_LEVEL_CONN, 'WSASetServiceW',[]);
end;

function Hook_WSAProviderConfigChange( var lpNotificationHandle : THandle; lpOverlapped : LPWSAOVERLAPPED; lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE ) : Integer; stdcall;
begin
     result := WSAProviderConfigChange(lpNotificationHandle, lpOverlapped, lpCompletionRoutine);
     Log(LOG_LEVEL_CONN, 'WSAProviderConfigChange',[]);
end;


{* DNS stuff *}
function Hook_getaddrinfo(nodename, servname: PChar; hints: PAddrInfo; res: PPAddrInfo): integer; stdcall;
begin
     result := my_getaddrinfo(nodename, servname, hints, res);
     Log(LOG_LEVEL_CONN, 'getaddrinfo(%s) = %d', [nodename, result]);
end;

procedure Hook_freeaddrinfo(ai: PAddrInfo); stdcall;
begin
     Log(LOG_LEVEL_CONN, 'freeaddrinfo',[]);
     my_freeaddrinfo(ai);
end;

function Hook_gethostbyname(name: PChar): PHostEnt; stdcall;
var
   ph: PHostAddr;
   nm: string;
begin
     result := my_gethostbyname(name);

     if (result <> nil) then
     begin
          if name = nil then
             nm := 'nil'
          else
             nm := name;

          ph := PHostAddr(result^.h_addr_list^);
          if (ph <> nil) then
             Log(LOG_LEVEL_CONN, 'gethostbyname (%s) = %s', [nm, GetDottedIP(DWORD(ph^))])
          else
             Log(LOG_LEVEL_CONN, 'gethostbyname (%s) = nil', [nm]);
     end
     else
          Log(LOG_LEVEL_CONN, 'gethostbyname (%s) = nil', [nm]);
end;

function Hook_WSAAsyncGetHostByName(HWindow: HWND; wMsg: u_int; name: PChar; buf: PHostEnt; buflen: Integer): THandle; stdcall;
var
   buf1: PHostEnt;
   ph: PHostAddr;
begin
     result := 0;
     
     if (prog_resolve_dns = 0) then
       result := WSAAsyncGetHostByName(HWindow, wMsg, name, buf, buflen)
     else if (prog_resolve_dns = 1) then
     begin
          result := WSAAsyncGetHostByName(HWindow, wMsg, name, buf, buflen);
          if result = 0 then
          begin
               result := 2;
               buf1 := my_gethostbyname(name);

               if (buf1 <> nil) then
               begin
                    Move(buf1^, buf^, SizeOf(THostEnt));
                    ph := PHostAddr(buf1^.h_addr_list^);
                    if (ph <> nil) then
                      Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName (%s) = %s', [name, GetDottedIP(DWORD(ph^))])
                    else
                      Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName(%s) = nil', [name]);
               end
               else
               begin
                    Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName(%s) = nil', [name]);
               end;
               PostMessage(HWindow, wMsg, result, buflen);
          end;
     end
     else if (prog_resolve_dns = 2) then
     begin
          result := 2;
          buf1 := my_gethostbyname(name);

          if (buf1 <> nil) then
          begin
               Move(buf1^, buf^, SizeOf(THostEnt));
               ph := PHostAddr(buf1^.h_addr_list^);
               if (ph <> nil) then
                 Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName (%s) = %s', [name, GetDottedIP(DWORD(ph^))])
               else
                 Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName(%s) = nil', [name]);
          end
          else
          begin
               Log(LOG_LEVEL_CONN, 'WSAAsyncGetHostByName(%s) = nil', [name]);
          end;
          PostMessage(HWindow, wMsg, result, buflen);
     end;

end;


{ * * * * * *  * * * * * *  * * * * * *  * * * * * *  * * * * * *  * * * * * * }
{ * * * * * *  * * * * * *  * * * * * *  * * * * * *  * * * * * *  * * * * * * }

{* Init our hook table with "real" function addresses
 *}
procedure PrepareWSockHooks();
var
   Import_ws2: Boolean;
   i: integer;
   ws2h: HMODULE;
begin
     i := 0;
     Import_ws2 := IsImported(GetModuleHandle(nil), 'ws2_32.dll');
     ws2h := GetModuleHandle('ws2_32.dll');

     while i <= High(HookedFunctions) do
     begin
          if isWin9x then
             HookedFunctions[i].fnOrig := GetRealAddress(GetProcAddress(GetModuleHandle(HookedFunctions[i].fnModule), PChar(HookedFunctions[i].fnName)))
          else
          begin
               if Import_ws2 then
                 HookedFunctions[i].fnOrig := GetRealAddress(GetProcAddress(ws2h, PChar(HookedFunctions[i].fnName)))
               else
                 HookedFunctions[i].fnOrig := GetRealAddress(GetProcAddress(GetModuleHandle(HookedFunctions[i].fnModule), PChar(HookedFunctions[i].fnName)));
          end;

          if (HookedFunctions[i].fnOrig = nil) then
          begin
               if (not isWinXP) and (HookedFunctions[i].fnName <> 'getaddrinfo') and (HookedFunctions[i].fnName <> 'freeaddrinfo') then
                 Log(LOG_LEVEL_WARN, 'PrepareWSockHooks() !!!ERROR!!! I failed to get function %s from %s!!!',[HookedFunctions[i].fnName, HookedFunctions[i].fnModule]);
          end;
          inc(i);
     end;
end;

{* Install winsock hooks of module strModule (can be wsock32.dll or ws2_32.dll)
 *}
procedure InstallWSockHooks(strModule: string);
var
   i: integer;
   Import_ws2, bWin9x: Boolean;
begin
     Import_ws2 := IsImported(GetModuleHandle(nil), 'ws2_32.dll');
     bWin9x := isWin9x();

     for i:=0 to High(HookedFunctions) do
     begin
          if HookedFunctions[i].fnOrig <> nil then
          begin
               if bWin9x then
                 HookedFunctions[i].fnOrig := InstallHook('wsock32.dll', HookedFunctions[i].fnName, HookedFunctions[i].fnNew)
               else
               begin
                    if Import_ws2 then
                      HookedFunctions[i].fnOrig := InstallHook('ws2_32.dll', HookedFunctions[i].fnName, HookedFunctions[i].fnNew)
                    else
                      HookedFunctions[i].fnOrig := InstallHook(HookedFunctions[i].fnModule, HookedFunctions[i].fnName, HookedFunctions[i].fnNew)
               end;
          end
          else
          begin
               if (not isWinXP) and (HookedFunctions[i].fnName <> 'getaddrinfo') and (HookedFunctions[i].fnName <> 'freeaddrinfo') then
                 Log(LOG_LEVEL_WARN, 'InstallWSockHooks() !!!ERROR!!! I failed to install function %s in %s!!!',[HookedFunctions[i].fnName, HookedFunctions[i].fnModule]);
          end;
     end;
end;


procedure InstallWSockHooks2(hMod: HMODULE);
var
   i: integer;
   Import_wsock : Boolean;
   Import_ws2: Boolean;
   num_hooks: integer;
begin
     num_hooks := 0;
     Import_wsock := IsImported(hMod, 'wsock32.dll');
     Import_ws2 := IsImported(hMod, 'ws2_32.dll');

     if (not Import_wsock) and (not Import_ws2) then exit;


     for i:=0 to High(HookedFunctions) do
     begin
          if HookedFunctions[i].fnOrig <> nil then
          begin
               if Import_wsock then
                 inc(num_hooks, ReplaceIATEntryInOneMod('wsock32.dll', HookedFunctions[i].fnOrig, HookedFunctions[i].fnNew, hMod, True));
               if Import_ws2 then
                 inc(num_hooks, ReplaceIATEntryInOneMod('ws2_32.dll', HookedFunctions[i].fnOrig, HookedFunctions[i].fnNew, hMod, True));
          end;
     end;
     Log(LOG_LEVEL_INJ, '%d''s WinSock hooks placed', [num_hooks]);
end;


function GetHookedProc(fnName: string; fnOrig: Pointer): Pointer;
var
   i: integer;
begin
     result := nil;
     for i:=0 to High(HookedFunctions) do
     begin
          if isWin9x then
          begin
               if (fnOrig <> nil) and ((HookedFunctions[i].fnOrig = fnOrig)) then
               begin
                    result := HookedFunctions[i].fnNew;
                    exit;
               end;
          end
          else
          begin
              if (fnOrig <> nil) and ((HookedFunctions[i].fnOrig = fnOrig) or (HookedFunctions[i].fnName = fnName)) then
              begin
                   result := HookedFunctions[i].fnNew;
                   exit;
              end;
          end;
     end;
end;



end.


