{*
 * File: ...................... plugin.pas
 * Autor: ..................... Maxim Artemev aka Bert Raccoon
 * Copyright: ................. (c) 2004 by Max Artemev
 * Desc: ...................... Plugins declarations
 *}
unit plugin;

interface
uses Windows, SysUtils;

const
     MAX_ARRAY_VALUES = 32;

type
    TProcedure = procedure; stdcall;
    TBuffer = array[0..65535] of Char;
    TLog = procedure (fmt: PChar; args: array of const); stdcall;

    {*
     * This structure passes to OnSendRecv handler
     *}
    TSendRecvInfo = packed record
       App : PChar; // Application who initiates trasmiting/recieving
       Addr: PChar; // Destination address
       Port: Word;  // Port that used
    end;

    // This function *MUST* return size of result buffer, even if its haven't changed them
    TOnSendRecv = function (SendRecvInfo: TSendRecvInfo; Buffer: Pointer; Size: DWORD): DWORD; stdcall;

    TPluginHooks = packed record
      Init: TProcedure;    // Calls when plugin is loaded. May be nil
      Fini: TProcedure;    // Calls before plugin's unloading. May be nil
      OnSend: TOnSendRecv; // Calls before 'main program' will send data. May be nil
      OnRecv: TOnSendRecv; // Calls before 'main program' will recieve data. May be nil
    end;

    PPluginInfo = ^TPluginInfo;
    TPluginInfo = packed record
      Ports : array[0..MAX_ARRAY_VALUES - 1] of Word;  // list of ports for plugin bindings, last item should be zero
      Addrs : array[0..MAX_ARRAY_VALUES - 1] of PChar; // list of addresses for plugin bindings, last item should be nil
      Apps  : array[0..MAX_ARRAY_VALUES - 1] of PChar; // list of applications for plugin bindings, last item should be nil
      Name  : PChar;
      Author: PChar;
      Description: PChar;
      Hooks: TPluginHooks; // Pointer to plugin hooks structure
      InvokeConfigWnd: TProcedure; // procedure for showing 'Config Window' of plugin
    end;

    TFreeCapMain = packed record
       Log: TLog;
    end;


implementation
end.
